#! /bin/bash

# This script copies the Anno source files to their location.
# See details from INSTALL file.

if [ $# -ne 1 -o ! -d "$1" ]; then
	echo Usage:
	echo $0 moodledir
	echo 
	echo "where moodledir is the root of the Moodle installation to add Anno to."
	exit 1
fi


dest=$1
# remove trailing "/"
dest=`echo $dest|sed 's/\/$//'`
basedir=$dest/anno

# Be paranoid and make sure there is nothing in the way - not even a pre-existing installation
if [ -d $basedir ]; then
        echo "Error: Something with the same name as the install directory exists already!"
        echo "       You must remove it by hand:"
        echo "       $basedir"
        exit 1
fi

if [ ! -w $dest -o ! -w "$dest/lib/weblib.php" ]; then
	echo "We don't have write permission to the Moodle installation. Exiting."
	exit 1
fi

echo "Creating install directory $basedir."
mkdir -p $basedir || ( echo "Couldn't create $basedir, exiting." && exit 1 )

echo "Copying files."
cp -pr src/{handler_module,ui_module,utf8} $basedir/. || ( echo "Copying failed. Please check. Exiting." && exit 1 )

echo
echo "Copying succeeded. Next you must create the sql tables "
echo "and configure your Anno. Finally patch your Moodle."
