/*  Anno - a system for interoperation of Moodle with an Annotea server.
    Anno is a modified version of Mooan.
    Anno  Copyright (C) 2007 Jukka Huhta, Juho Iso-Markku, Jarno Laitinen,
                        Timo Myyrylinen, Roger Sandstrm, Miro Wikgren
    Mooan Copyright (C) 2006  Heikki Aitakangas, Mika Holmstrm,
                        Kirsi Jokisalo, Anni Kotilainen, Esko Lehtonen,
                        Paula Urpilainen
    
    This program is free software; you can redistribute it and/or modify
    it under the terms of the GNU General Public License as published by
    the Free Software Foundation; either version 2 of the License, or
    (at your option) any later version.
    
    This program is distributed in the hope that it will be useful,
    but WITHOUT ANY WARRANTY; without even the implied warranty of
    MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
    GNU General Public License for more details.
    
    You should have received a copy of the GNU General Public License along
    with this program; if not, write to the Free Software Foundation, Inc.,
    51 Franklin Street, Fifth Floor, Boston, MA 02110-1301 USA.
*/ 
/**
 * Functions to open various views (new comment view, reply view, large view).
 *
 * @author  ??
 * @license http://www.gnu.org/copyleft/gpl.html GNU General Public License
 *
 * Created by mooan-group August 2006 for the Mooan-software project and
 * modified by anno3-group May 2007 for the Anno-software project
 * at the Department of Computer science, University of Helsinki.
 *
 */

/**
 * Sets new comment view on/off
 * 
 * @param status on/off
 */
function anno_set_view_pane_new_comment_visible(status) {
    var view_pane = document.getElementById("anno_view_pane_new_comment");
    
    if (status) {
        view_pane.style.display = "block";
    } else {
        view_pane.style.display = "none";
    }
}


/**
 * Sets big window on/off
 *
 * @param status on/off
 */
function anno_set_view_pane_big_visible(status) {
    var view_pane = document.getElementById("anno_view_pane_big");

    if (status) {
        view_pane.style.display = "block";

        // We need to copy the content of the selected comment tree
        var commenttree = document.getElementById("anno_frame_" + anno_current_root_id);
        var frame = document.getElementById("anno_view_pane_big_comment_tree");

        // Clone the comment tree and its children
        var clone = commenttree.cloneNode(true);

        // Remove the old comment tree, if there is one
        if (frame.hasChildNodes()) {
            frame.removeChild(frame.firstChild);
        }

        // Avoid id clashes
        function anno_rename_recursively(e) {
            try {
                e.id = e.id + "_stub2";

                if (e.hasChildNodes()) {
                    var children = e.childNodes;
                    for (var i=0; i<children.length; i++) {
                        anno_rename_recursively(children[i]);
                    }
                }
            } catch (e) {};
        }
        anno_rename_recursively(clone);

        frame.appendChild(clone);
        
        // Fix the style
        clone.style.width = "60%";
        clone.style.height = "12em";
        clone.style.margin = "0 auto";

    } else {
        view_pane.style.display = "none";
    }
}


/**
 * Sets reply view on/off
 *
 * @param status on/off
 */
function anno_set_view_pane_reply_visible(status) {
    var view_pane = document.getElementById("anno_view_pane_reply");
    if (status) { 
        // We need to copy the content of the selected comment tree
        var commenttree = document.getElementById("anno_frame_" + anno_current_root_id);
        var frame = document.getElementById("anno_view_pane_reply_tree");

        // Clone the comment tree and its children.
        var clone = commenttree.cloneNode(true);

        // Remove the old comment tree, if there is one.
        if (frame.hasChildNodes()) {
            frame.removeChild(frame.firstChild);
        }

        // Avoid id clashes
        function anno_rename_recursively(e) {
            try {
                e.id = e.id + "_stub";

                if (e.hasChildNodes()) {
                    var children = e.childNodes;
                    for (var i=0; i<children.length; i++) {
                        anno_rename_recursively(children[i]);
                    }
                }
            } catch (e) {};
        }
        anno_rename_recursively(clone);

        frame.appendChild(clone);

        // Fix the style
        clone.style.height = "12em";

        // If the user has highlighted a message, we need to remove this.
        if (anno_previous_reply_target_id != null) {
            var target1 = document.getElementById("anno_comment_view_" + anno_previous_reply_target_id + "_stub");
            if (target1) { 
                target1.style.backgroundColor = "#FFFFFF";
            }
        }

        // Find and highlight the message we are commenting now.
        var target2 = document.getElementById("anno_comment_view_" + anno_current_reply_target_id + "_stub");

        target2.style.backgroundColor = "#F0F8FE";

        anno_previous_reply_target_id = anno_current_reply_target_id;

        view_pane.style.display = "block";
    } else {
         view_pane.style.display = "none";
        // If the use has highlighted a message, we need to remove this.
        if (anno_previous_reply_target_id != null) {
            var target = document.getElementById("anno_comment_view_" + anno_previous_reply_target_id + "_stub");
            target.style.backgroundColor = "#FFFFFF";
        }
    }
}
